/*
Copyright (c)  2013   The Regents of the University of California
All Rights Reserved
 
Permission to copy, modify and distribute any part of this FlowMax for educational, research and non-profit purposes, without fee, and without a written agreement is hereby granted, provided that the above copyright notice, this paragraph and the following three paragraphs appear in all copies.
Those desiring to incorporate this FlowMax into commercial products or use for commercial purposes should contact the Technology Transfer Office, University of California, San Diego, 9500 Gilman Drive, Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS FlowMax, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
THE FlowMax PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED OR EXPRESS, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, OR THAT THE USE OF THE FlowMax WILL NOT INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
*/
package FlowMax;

import java.io.File;
import java.util.LinkedList;

import common.FCS;
import common.Matrix;
import common.MaxList;
import common.Point;
import common.TreeNode;

public class FMFCS extends FCS{

	private FMTreeNode ready;
	
	public FMTreeNode getReady() {
		return ready;
	}

	public void setReady(FMTreeNode ready) {
		this.ready = ready;
	}

	public FMFCS(File source) {
		super(source);
		// TODO Auto-generated constructor stub
	}
	
	public FMFCS(FCS copy)
	{
		super(copy);
	}
	
	public void initializeDataSize(int size, int num_par)
	{
		this.num_par = num_par;
		inverse = Matrix.identityMatrix(num_par);
		data = new LinkedList<Point>();
		maxes = new int[num_par];
		initializeTrueRoot();
	}
	
	public void initializeTrueRoot()
	{
		FMTreeNode trueRoot = new FMTreeNode(getArrayData(), this);
		root = new FMTreeNode(new LinkedList<Point>(),this);
		trueRoot.getLeaves().add(root);
		root.setParent(trueRoot);
	}
	
	public FMTreeNode getRoot()
	{
		if(root == null)
		{
			initializeTrueRoot();
		}
		return (FMTreeNode)root;
	}

	/**
	 * Propagates down the branches until a ready node is found. Ready field is updated. Status returned.
	 * @return true if ready, false otherwise
	 */
	public boolean checkIfReady() {
		FMTreeNode answer = getRoot().getReady();
		if(answer != null)
		{
			ready = answer;
			return true;
		}
		return false;
	}
	


}
