/*
Copyright (c)  2013   The Regents of the University of California
All Rights Reserved
 
Permission to copy, modify and distribute any part of this FlowMax for educational, research and non-profit purposes, without fee, and without a written agreement is hereby granted, provided that the above copyright notice, this paragraph and the following three paragraphs appear in all copies.
Those desiring to incorporate this FlowMax into commercial products or use for commercial purposes should contact the Technology Transfer Office, University of California, San Diego, 9500 Gilman Drive, Mail Code 0910, La Jolla, CA 92093-0910, Ph: (858) 534-5815, FAX: (858) 534-7345, E-MAIL:invent@ucsd.edu.
IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS FlowMax, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
THE FlowMax PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.  THE UNIVERSITY OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES OF ANY KIND, EITHER IMPLIED OR EXPRESS, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, OR THAT THE USE OF THE FlowMax WILL NOT INFRINGE ANY PATENT, TRADEMARK OR OTHER RIGHTS.
*/
package FlowMax;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import common.Graph;
import common.Plotter;
import common.TreeNode;

public class FMGraph extends Graph {

	public FMGraph(FMTreeNode node, FMPlotter parent) {
		super(node, parent);
		// TODO Auto-generated constructor stub
	}
	
	protected void drawOnGraphics(Graphics2D g2)
	{
		super.drawOnGraphics(g2,true);
		//lets draw the first peak indicator
		if(node.yindex==-1 && ((FMTreeNode)node).first_peak != 0)
		{
			g2.setColor(Color.RED);
			int x = ((FMTreeNode)node).first_peak;
			if(x > 0)
			{
				int hx;
				double xmin2, xmax2;
				xmin2 = node.xmin;
				xmax2 =node.xmax;
				if(node.xlog)
				{
					xmin2 = Math.log10(node.xmin);
					xmax2 =Math.log10(node.xmax);
					double x2 = Math.log10(x);
					double f = (x2-xmin2)/(xmax2-xmin2);
					hx = (int)(f*img.getWidth());
				}
				else
				{
					hx = (int) ((((double)(x-xmin2))/(xmax2-xmin2))*(img.getWidth()));
				}
				int newx = hx+ymargin;
				for(int i = 0; i < getHeight()-xmargin; i++)
				{
					g2.setColor(new Color((i/((float)(getHeight()-xmargin))),0f,0f));
					g2.drawLine(newx, i, newx, i+1);
				}
			}
		}
	}

	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D)g;
		drawOnGraphics(g2);
	}
}
