package common;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.awt.image.BufferedImage;
import java.util.ArrayList;

import javax.swing.JPanel;

public class Colorer extends JPanel
{
	protected int selected = 0;
	double divider = 1; 
	double[] red = new double[2];
	double[] green = new double[2];
	double[] blue = new double[2];
	double w;
	double h;
	boolean need_redraw = true;
	BufferedImage pallete;
	int yclick = -1;

	
	public Colorer()
	{
		super();
		addComponentListener(new ComponentListener(){

			@Override
			public void componentHidden(ComponentEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void componentMoved(ComponentEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void componentResized(ComponentEvent arg0) {
				// TODO Auto-generated method stub
				updateUI();
			}

			@Override
			public void componentShown(ComponentEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});
		this.addMouseListener(new MouseListener(){

			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void mouseEntered(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void mouseExited(MouseEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void mousePressed(MouseEvent e) {
				// TODO Auto-generated method stub
				if(e.getButton() == MouseEvent.BUTTON3)
					yclick = e.getY();
			}

			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				int i = e.getX();
				int j = e.getY();
				double dr = Math.sqrt((red[0]-i)*(red[0]-i)+(red[1]-j)*(red[1]-j));
				double dg = Math.sqrt((green[0]-i)*(green[0]-i)+(green[1]-j)*(green[1]-j));
				double db = Math.sqrt((blue[0]-i)*(blue[0]-i)+(blue[1]-j)*(blue[1]-j));
				//System.err.println("Clicked! "+dr+" "+dg+" "+db+" "+w);
				if(dr <= w && dg <= w && db <= w)
				{
					int rd = (int)Math.min(Math.max(1,((255 - (255*dr)/(w))/divider)),255);
					int grn =  (int)Math.min(Math.max(1,((255 - (255*dg)/(w))/divider)),255);
					int bl =   (int)Math.min(Math.max(1,((255 - (255*db)/(w))/divider)),255);
					
					Color c = new Color(rd,grn,bl);
					selected = c.getRGB();
					colorSelected();
					need_redraw = true;
					updateUI();

				}
				yclick = -1;
			}
			
		});
		this.addMouseMotionListener(new MouseMotionListener(){

			public void mouseDragged(MouseEvent arg0) {
				// TODO Auto-generated method stub
				if(yclick != -1)
				{
					int diff = arg0.getY()-yclick;
					if(diff > 0 && divider <255)
						divider=Math.min(1+diff*0.01,255);
					else if(diff < 0 && divider > 0)
					{
							divider=Math.max(1+diff*0.005,0.00001);
					}
					need_redraw = true;
					updateUI();
				}
			}

			public void mouseMoved(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});
		
		
		this.addMouseWheelListener(new MouseWheelListener(){

			public void mouseWheelMoved(MouseWheelEvent arg0) {
				if(arg0.getWheelRotation() > 0 && divider <255)
					divider=(1+arg0.getWheelRotation()*0.1)*divider;
				else if(arg0.getWheelRotation() < 0 && divider > 0)
				{
					divider=divider/(1-(arg0.getWheelRotation()*0.1));
				}
				need_redraw=true;
				updateUI();
			}
			
		});
	}
	
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;
		if(pallete == null|| need_redraw)
		{
			need_redraw = false;
			pallete = new BufferedImage(getWidth(),getHeight(),BufferedImage.TYPE_INT_RGB);
			w = getWidth();
			h = getHeight();
			red[0] = w/2;
			red[1] = 0;
			double y =(w)*Math.sqrt(3)/2;
			green[0] = 0;
			green[1] = y;
			blue[0] = w;
			blue[1] = y;
		//	System.err.println(red[0]+","+red[1]);
		//	System.err.println(green[0]+","+green[1]);
		//	System.err.println(blue[0]+","+blue[1]);
			for(int i = 0; i < w;i++)
			{
				for(int j = 0; j < h; j++)
				{
					double dr = Math.sqrt((red[0]-i)*(red[0]-i)+(red[1]-j)*(red[1]-j));
					double dg = Math.sqrt((green[0]-i)*(green[0]-i)+(green[1]-j)*(green[1]-j));
					double db = Math.sqrt((blue[0]-i)*(blue[0]-i)+(blue[1]-j)*(blue[1]-j));
					if(dr <= w && dg <= w && db <= w)
					{
					
						int rd = (int)Math.min(Math.max(0,((255 - (255*dr)/(w))/divider)),255);
						int grn =  (int)Math.min(Math.max(0,((255 - (255*dg)/(w))/divider)),255);
						int bl =   (int)Math.min(Math.max(0,((255 - (255*db)/(w))/divider)),255);
						pallete.setRGB(i, j, (new Color(rd,grn,bl)).getRGB());
					}
					else
						pallete.setRGB(i,j,selected);
				}
			}
		}
		g2.drawImage(pallete,0,0,null);
	}
	
	protected void colorSelected()
	{
		
	}
}
