package common;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class Compensator extends JFrame{
	
	String[] names;
	ArrayList<CompEntry> entries = new ArrayList<CompEntry>();
	JList elist;
	FCS FCS;
	Gallery gal;
	
	JComboBox targetBox;
	JComboBox subtractBox;
	JSpinner amount;
	JButton delBtn;
	JButton addBtn;
	JButton compensateBtn;
	int sel_ind = 0;
	
	boolean justrebuilt = false;
	
	public Compensator (FCS fcs, Gallery gallery)
	{
		gal = gallery;
		setCompensation(fcs);
	}
	
	public void setCompensation(FCS fcs)
	{
		this.FCS = fcs;

		names = fcs.getNames();
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		Container cp = this.getContentPane();
		cp.removeAll();
		cp.setLayout(new BorderLayout(5,5));
		JPanel top = new JPanel(new FlowLayout(FlowLayout.LEFT,1,1));
		targetBox = new JComboBox(names);
		targetBox.addItemListener(new ItemListener(){

			public void itemStateChanged(ItemEvent arg0) {
				// TODO Auto-generated method stub
				/*
				if(sel_ind < entries.size())
				{
					CompEntry selected = entries.get(sel_ind);
					if(selected != null)
					{
						selected.target = targetBox.getSelectedIndex();
						((DefaultListModel)elist.getModel()).remove(sel_ind);
						((DefaultListModel)elist.getModel()).add(sel_ind,((String)targetBox.getSelectedItem())+" - "+String.format("%3.2f",(Double)amount.getValue())+"% "+((String)subtractBox.getSelectedItem()));
					}
				}
				*/
			}
			
		});
		subtractBox = new JComboBox(names);
		subtractBox.addItemListener(new ItemListener(){

			@Override
			public void itemStateChanged(ItemEvent arg0) {
				// TODO Auto-generated method stub
				/*
				if(sel_ind < entries.size())
				{
					CompEntry selected = entries.get(sel_ind);
					if(selected != null)
					{
						selected.sub = subtractBox.getSelectedIndex();
						((DefaultListModel)elist.getModel()).remove(sel_ind);
						((DefaultListModel)elist.getModel()).add(sel_ind,((String)targetBox.getSelectedItem())+" - "+String.format("%3.2f",(Double)amount.getValue())+"% "+((String)subtractBox.getSelectedItem()));
					}
				}
				*/
			}
			
		});
		amount = new JSpinner(new SpinnerNumberModel(0, 0, 100, 0.1));
		amount.addChangeListener(new ChangeListener(){

			@Override
			public void stateChanged(ChangeEvent arg0) {
				//lets search forthe entry that this corresponds to
				if(sel_ind < entries.size())
				{
					CompEntry selected = entries.get(sel_ind);
					if(selected != null && selected.sub==subtractBox.getSelectedIndex() && selected.target == targetBox.getSelectedIndex())
					{
						selected.amount = (Double)amount.getValue();
						((DefaultListModel)elist.getModel()).remove(sel_ind);
						((DefaultListModel)elist.getModel()).add(sel_ind,FCS.getNames()[selected.target]+" - "+String.format("%3.2f",(Double)amount.getValue())+"% "+FCS.getNames()[selected.sub]);
					}
				}
			}
		});
		addBtn = new JButton("Add");
		addBtn.addActionListener(new ActionListener(){

			@Override
			public void actionPerformed(ActionEvent arg0) {
				CompEntry selected = null;
				for(int i = 0; i < entries.size(); i++)
				{
					if(entries.get(i).sub == subtractBox.getSelectedIndex() && entries.get(i).target == targetBox.getSelectedIndex())
					{
						selected = entries.get(i);
						break;
					}
				}
				if(selected == null)
				{
					CompEntry ce = new CompEntry(targetBox.getSelectedIndex(),subtractBox.getSelectedIndex(),(Double)amount.getValue());
					entries.add(ce);
					((DefaultListModel)elist.getModel()).addElement(((String)targetBox.getSelectedItem())+" - "+(Double)amount.getValue()+"% "+((String)subtractBox.getSelectedItem()));
				}
				else
				{
					selected.amount = (Double)amount.getValue();
					((DefaultListModel)elist.getModel()).remove(sel_ind);
					((DefaultListModel)elist.getModel()).add(sel_ind,FCS.getNames()[selected.target]+" - "+String.format("%3.2f",(Double)amount.getValue())+"% "+FCS.getNames()[selected.sub]);
				}
			}		
		});
		delBtn = new JButton("Remove");
		delBtn.addActionListener(new ActionListener(){

			@Override
			public void actionPerformed(ActionEvent arg0) {
				CompEntry selected = entries.get(sel_ind);
				if(selected != null)
				{
					entries.remove(selected);
					((DefaultListModel)elist.getModel()).remove(sel_ind);
				}
			}		
		});
		elist = new JList(new DefaultListModel());
		elist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		elist.addMouseListener(new MouseListener(){

			@Override
			public void mouseClicked(MouseEvent arg0) {
				// TODO Auto-generated method stub
				CompEntry ce = entries.get(elist.getMinSelectionIndex());
				targetBox.setSelectedIndex(ce.target);
				subtractBox.setSelectedIndex(ce.sub);
				((SpinnerNumberModel)amount.getModel()).setValue(ce.amount);
				sel_ind = Math.max(elist.getMinSelectionIndex(),0);
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void mousePressed(MouseEvent arg0) {
				

				
			}

			@Override
			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});
		translateEntities(fcs);
		top.add(targetBox);
		top.add(new JLabel(" - "));
		top.add(amount);
		top.add(new JLabel("%"));
		top.add(subtractBox);
		top.add(addBtn);
		top.add(delBtn);
		cp.add(top,BorderLayout.NORTH);
		cp.add(elist,BorderLayout.CENTER);
		compensateBtn = new JButton("Compensate");
		compensateBtn.addActionListener(new ActionListener(){

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				Matrix mat = Matrix.identityMatrix(names.length);
				for(int i = 0; i < entries.size(); i++)
				{
					mat.setElement(entries.get(i).target, entries.get(i).sub, entries.get(i).amount/100.0);
				}
				FCS.setInverse(mat.inverse());
				FCS.propagateColors();
				FCS.getRoot().propagateFromRoot();
				gal.updateAll();
			}
			
		});
		cp.add(compensateBtn,BorderLayout.SOUTH);
		cp.invalidate();
		setSize(350,200);
		setTitle("Compensate "+fcs.getExperiment());
		setResizable(false);
		setVisible(true);
		
	}
	
	private void translateEntities(FCS f) {
		entries.clear();
		Matrix mat = f.getInverse().inverse();
		int count = 0;
		for(int i = 0; i < mat.getNrow(); i++)
		{
			for(int j = 0; j < mat.getNcol();j++)
			{
				if((i!=j && mat.getElement(i, j)!= 0) || (i==j && mat.getElement(i, j) != 1)){
					CompEntry ce = new CompEntry(i,j,mat.getElement(i, j)*100.0);
					entries.add(ce);
					((DefaultListModel)elist.getModel()).add(count++,f.getNames()[i]+" - "+String.format("%3.2f",ce.amount)+"% "+f.getNames()[j]);
				}
			}
		}
		
	}

	private class CompEntry
	{
		int target;
		int sub;
		double amount; 
		
		public CompEntry(int target, int sub, double amount)
		{
			this.target = target; this.sub = sub; this.amount = amount;
		}
		
	}

}
