package common;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.filechooser.FileFilter;




public class Dialogs 
{
	public static File getFolderFile(String title)
	{
		JFileChooser fc = new JFileChooser(".");
		fc.setDialogTitle(title);
		fc.setMultiSelectionEnabled(false);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fc.setFileFilter(new FileFilter(){

			@Override
			public boolean accept(File arg0) {
				// TODO Auto-generated method stub
				if( arg0.isDirectory())
					return true;
				else
					return false;
			}

			@Override
			public String getDescription() {
				// TODO Auto-generated method stub
				return "Folder";
			}
			
		});
		if(fc.showOpenDialog(null)==0)
		{
			return fc.getSelectedFile();
		}
		else return null;
	}
	
	
	public static File getOpenFile(final String suffix, String title)
	{
		suffix.replaceAll("\\\\.", "");
		JFileChooser fc = new JFileChooser(".");
		fc.setDialogTitle(title);
		fc.setMultiSelectionEnabled(false);
		fc.setFileFilter(new FileFilter(){

			@Override
			public boolean accept(File arg0) {
				// TODO Auto-generated method stub
				if(arg0.getName().endsWith(suffix) || arg0.isDirectory())
					return true;
				else
					return false;
			}

			@Override
			public String getDescription() {
				// TODO Auto-generated method stub
				return suffix;
			}
			
		});
		if(fc.showOpenDialog(null)==0)
		{
			return fc.getSelectedFile();
		}
		else return null;
	}
	
	public static File getSaveFile(final String suffix, String title)
	{
		JFileChooser fc = new JFileChooser(".");
		fc.setDialogTitle(title);
		fc.setMultiSelectionEnabled(false);
		fc.setFileFilter(new FileFilter(){

			@Override
			public boolean accept(File arg0) {
				// TODO Auto-generated method stub
				if(arg0.getName().endsWith(suffix) || arg0.isDirectory())
					return true;
				else
					return false;
			}

			@Override
			public String getDescription() {
				// TODO Auto-generated method stub
				return suffix;
			}
			
		});
		if(fc.showSaveDialog(null)==0)
		{
			if(fc.getSelectedFile().getName().endsWith(suffix))
				return fc.getSelectedFile();
			else 
				return new File(fc.getSelectedFile().getAbsolutePath()+"."+suffix);
		}
		else return null;
	}
	
	public static File[] getOpenFiles(final String suffix, String title)
	{
		JFileChooser fc = new JFileChooser(".");
		fc.setDialogTitle(title);
		fc.setMultiSelectionEnabled(true);
		fc.setFileFilter(new FileFilter(){

			@Override
			public boolean accept(File arg0) {
				// TODO Auto-generated method stub
				if(arg0.getName().endsWith(suffix) || arg0.isDirectory())
					return true;
				else
					return false;
			}

			@Override
			public String getDescription() {
				// TODO Auto-generated method stub
				return suffix;
			}
			
		});
		if(fc.showOpenDialog(null)==0)
		{
			return fc.getSelectedFiles();
		}
		else return new File[0];
	}
	
	public static String getSelection(Iterator<String> selections,String prompt)
	{
		ArrayList<String> list = new ArrayList<String>();
		while(selections.hasNext())
		{
			list.add(selections.next());
		}
		String s = (String)JOptionPane.showInputDialog(
                null,
                prompt,
                "Choose one:",
                JOptionPane.PLAIN_MESSAGE,
                null, list.toArray(),
                "ham");
		return s;
	}
	
	
	public static double getDouble(String prompt, double min, double max, double step)
	{
		JSpinner spinner = new JSpinner(new SpinnerNumberModel(min,min,max,step));
		final JComponent[] inputs = new JComponent[] {
		                new JLabel(prompt),
		                spinner
		};
		JOptionPane.showMessageDialog(null, inputs, "My custom dialog", JOptionPane.PLAIN_MESSAGE);
		return (Double)spinner.getValue();
	}

	public static void showBackgroundMessage(String string) {
		JFrame frame = new JFrame("Message:");
		JLabel lbl = new JLabel(string);
		frame.getContentPane().add(lbl);
		frame.setSize(string.length()*10,50);
		frame.setResizable(false);
		frame.pack();
		frame.setVisible(true);
		
	}
}
