package common;

/**
 * Class associated with reading in fluorescence parameters from the FCS file
 * @author Max
 *
 */
public class FCSSetting
{
	int bits=32;
	int amp_decades = 0;
	int range = 0;
	double amp_zero = 0;
	String name = "";
	int usefulBits = 0;
	int last_byte_multiplier;
	int max;
	int min;
	
	
	
	public int getBits() {
		return bits;
	}

	public int getAmp_decades() {
		return amp_decades;
	}

	public int getRange() {
		return range;
	}

	public double getAmp_zero() {
		return amp_zero;
	}

	public String getName() {
		return name;
	}

	public int getUsefulBits() {
		return usefulBits;
	}

	public int getLast_byte_multiplier() {
		return last_byte_multiplier;
	}

	public int getMax() {
		return max;
	}

	public int getMin() {
		return min;
	}
	
	public FCSSetting()
	{
		super();
		//do nothing;
	}

	public FCSSetting(int bits, int amp_decades, int range)
	{
		this.bits = bits;
		this.amp_decades = amp_decades;
		this.range = range;
		calculateUsefulBits();
	}
	
	public void calculateUsefulBits()
	{
		//uses the bits and range to compute the byteoffset to use when reading in the data
		int count = 0;
		int value = range;
		while(value > 1)
		{
			value=value/2;
			count++;
		}
		usefulBits = count;
		last_byte_multiplier =(int) Math.pow(2,usefulBits%8);
	}
}
