package common;
import java.util.ArrayList;



	public class Histogram
	{
		public static final int maximum = 16777216;
		public static final int minimum = 1;
		public double min =Math.log10(minimum);
		public double max = Math.log10(maximum);
		public double max_prob =0;
		public double prob[];

		public ArrayList<Double> raw = new ArrayList<Double>();
		
		public void rebin(int bins)
		{
			prob = new double[bins];
			double total_prob=0;
			for(int i = 0; i < raw.size(); i++)
			{
				int index = (int)((raw.get(i)-min)/(max-min)*bins);
				index = Math.min(bins-1, Math.max(0,index));
				prob[index]++;
				total_prob++;
			}
			for(int i = 0; i < bins; i++)
			{
				prob[i]= prob[i]/total_prob;
				if(prob[i] > max_prob) max_prob = prob[i];
			}

		}
		public void rebin(double size)
		{
			int bins = (int) ((max-min)/size);
			prob = new double[bins];
			double total_prob=0;
			for(int i = 0; i < raw.size(); i++)
			{
				int index = (int)((raw.get(i)-min)/(max-min)*bins);
				if(index == bins) index--;
				prob[index]++;
				total_prob++;
			}
			for(int i = 0; i < bins; i++)
			{
				prob[i]= prob[i]/total_prob;
				if(prob[i] > max_prob) max_prob = prob[i];
			}
			
		}
		
		public void removeEmptySpace()
		{
			min = Double.POSITIVE_INFINITY;
			max = Double.NEGATIVE_INFINITY;
			for(int i = 0; i < raw.size(); i++)
			{
				if(raw.get(i) < min) min = raw.get(i);
				if(raw.get(i) > max) max = raw.get(i);
			}
			rebin(prob.length);
		}
		
		public void resetMinMax(int bins, double a, double b)
		{
			min = a;
			max = b;
			rebin(bins);
		}
		
		public Histogram(ArrayList<Double> data, int bins)
		{
			/*
			for(int i = 0; i < data.size(); i++)
			{
				if(data.get(i) < min) min = data.get(i);
				if(data.get(i) > max) max = data.get(i);
			}
			*/
		//	if(data.size() > 2)System.err.println(data.get(0)+" "+data.get(1));
			for(int i = 0; i < data.size(); i++)
			{
				if(!Double.isInfinite(data.get(i)) && !Double.isNaN(data.get(i)) )
					raw.add(data.get(i));
			}
			rebin(bins);
		}
		
		public void mixIn(Histogram h)
		{
			double total_prob = 0;
			raw.addAll(h.raw);
			ArrayList<Double> data = raw;
			int bins = prob.length;
			prob = new double[bins];
			for(int i = 0; i < data.size(); i++)
			{
				if(data.get(i) < min) min = data.get(i);
				if(data.get(i) > max) max = data.get(i);
			}
			for(int i = 0; i < data.size(); i++)
			{
				int index = (int)((data.get(i)-min)/(max-min))*bins;
				if(index == bins) index--;
				prob[index]++;
				total_prob++;
			}
			for(int i = 0; i < bins; i++)
			{
				prob[i]= prob[i]/total_prob;
				if(prob[i] > max_prob) max_prob = prob[i];
			}
		}
		

		
	}
