package common;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JPanel;

public class Slider extends JPanel
{
	private double min= 0;
	private double max = 1;
	private double value = 0;
	private int margin = 10;
	private int text_size = 35;
	private int w,h;
	private String label = "";
	private Font font = new Font("Calibri",Font.PLAIN,12);
	private ActionListener al;
	
	public void setFont(Font f)
	{
		font = f;
	}
	
	public void setValue(double val)
	{
		this.value = Math.max(min, Math.min(max,val));
		updateUI();
	}

	public void addActionListener(ActionListener al)
	{
		this.al = al;
	}
	
	private void  setupListeners()
	{
		addMouseMotionListener(new MouseMotionListener(){

			public void mouseDragged(MouseEvent arg0) {
				// TODO Auto-generated method stub
				value = Math.max(min,Math.min(max,min+((double)(arg0.getX()-margin))/(w-2*margin-text_size)*(max-min)));
			//	System.err.println("value is "+value);
				try{
					repaint();
				}
				catch(Exception e)
				{
					//do nothing
				}
				if(al != null)
				al.actionPerformed(new ActionEvent(this,0,""));
			}

			public void mouseMoved(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});
		addMouseListener(new MouseListener(){

			public void mouseClicked(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mousePressed(MouseEvent arg0) {
				// TODO Auto-generated method stub
				value = Math.max(min,Math.min(max,min+((double)(arg0.getX()-margin))/(w-2*margin-text_size)*(max-min)));
				//	System.err.println("value is "+value);
				try{
					repaint();
				}
				catch(Exception e)
				{
					//do nothing
				}
				if(al!= null)
					al.actionPerformed(new ActionEvent(this,0,""));
			}

			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});

	}

	
	
	public Slider(String label,double m, double m2, double val)
	{
		super();
		this.label = label;
		this.min = m;
		this.max = m2;
		this.value = val;
		setupListeners();
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;
		w = getWidth();
		h = getHeight();
		g2.drawLine(margin, h-3, w-margin-text_size, h-3);
		double fraction = (value-min)/(max-min);
		int x = (int)(margin+fraction*(w-2*margin-text_size));
		for(double i = 0; i <= 1; i+=0.1)
		{
			int tick = (int)(margin+i*(w-2*margin-text_size));
			g2.drawLine(tick, h-6, tick, h);
		}
		g2.fillRect(x-1, h-10, 3, 10);
		g2.setFont(font);
		g2.drawString(String.format("%2.2f",value), w-text_size, h-10);
		g2.drawString(label, 1,9);
	}



	public Slider(String label,double m, double m2, double val, int mar, int ts)
	{
		super();
		this.label = label;
		this.min = m;
		this.max = m2;
		this.value = val;
		this.margin = mar;
		this.text_size = ts;
		setupListeners();
	}
	
	public void updateValue(double v)
	{
		this.value = v;
		this.updateUI();
		al.actionPerformed(new ActionEvent(this,0,""+v));
	}
	
	public double getValue()
	{
		return value;
	}
	
	public Slider()
	{
		super();
		setupListeners();
	}
}