package common;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JPanel;

public class SliderGroup extends JPanel
{
	private double max = 1;
	private double[] values;
	private int margin = 10;
	private int text_size = 35;
	private int w,h;
	private String[] labels;
	
	public void setValues(double[] vals)
	{
		this.values  = vals;
		updateUI();
	}
	
	private void  setupListeners()
	{
		addMouseMotionListener(new MouseMotionListener(){

			public void mouseDragged(MouseEvent arg0) {
				// TODO Auto-generated method stub
				int index = (values.length*arg0.getY())/getHeight();
				values[index] = Math.max(0.001,Math.min(max-values.length*0.001,((double)(arg0.getX()-margin))/(w-2*margin-text_size)*(max)));
				double total = 0;
				for(int i = 0; i < values.length; i++)
				{
					if(i!= index) total+=values[index];
				}
				double new_total = 0;
				for(int i = 0; i < values.length; i++)
				{
					if(i!= index) 
					{
						values[i] = (max-values[index]-values.length*0.001)*(values[i]/total);
						new_total+=values[i];
					}
				}
				for(int i = 0; i < values.length; i++)
				{
					if(i!= index) 
					{
						values[i] = (values[i]/new_total)*(max-values[index]-values.length*0.001);
					}
				}
				/*
				total = 0;
				for(int i = 0; i < values.length; i++)
					total+=values[i];
				
				for(int i = 0; i < values.length; i++)
					values[i]=values[i]/total;
					*/
			//	System.err.println("value is "+value);
				updateUI();
			}

			public void mouseMoved(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});
		addMouseListener(new MouseListener(){

			public void mouseClicked(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mousePressed(MouseEvent arg0) {
				// TODO Auto-generated method stub
				int index = (values.length*arg0.getY())/getHeight();
				values[index] = Math.max(0.001,Math.min(max-values.length*0.001,((double)(arg0.getX()-margin))/(w-2*margin-text_size)*(max)));
				double total = 0;
				for(int i = 0; i < values.length; i++)
				{
					if(i!= index) total+=values[index];
				}
				double new_total = 0;
				for(int i = 0; i < values.length; i++)
				{
					if(i!= index) 
					{
						values[i] = (max-values[index]-values.length*0.001)*(values[i]/total);
						new_total+=values[i];
					}
				}
				for(int i = 0; i < values.length; i++)
				{
					if(i!= index) 
					{
						values[i] = (values[i]/new_total)*(max-values[index]-values.length*0.001);
					}
				}
				/*
				total = 0;
				for(int i = 0; i < values.length; i++)
					total+=values[i];
				
				for(int i = 0; i < values.length; i++)
					values[i]=values[i]/total;
					*/
			//	System.err.println("value is "+value);
				updateUI();
			}

			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
		});

	}

	
	
	public SliderGroup(String[] labels,double m2)
	{
		super();
		this.labels = labels;
		this.max = m2;
		int val_count = labels.length;
		this.values = new double[val_count];
		for(int i = 0; i < values.length; i++)
			values[i] = max/val_count;
		setupListeners();
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;
		int c = values.length;
		w = getWidth();
		h = getHeight();
		for(int i = 0; i < labels.length ; i++)
		{
			g2.drawLine(margin, (i+1)*h/c-3, w-margin-text_size, (i+1)*h/c-3);
			double fraction = (values[i])/(max);
			int x = (int)(margin+fraction*(w-2*margin-text_size));
			for(double j = 0; j <= 1; j+=0.1)
			{
				int tick = (int)(margin+j*(w-2*margin-text_size));
				g2.drawLine(tick, (i+1)*h/c-6, tick, (i+1)*h/c);
			}
			g2.fillRect(x-1, (i+1)*h/c-10, 3, 10);
			g2.setFont(new Font("Arial",Font.PLAIN,10));
			g2.drawString(String.format("%3.3f",values[i]), w-text_size, (i+1)*h/c-10);
			g2.drawString(labels[i], 1,(i)*h/c+15);
		}
	}


	
	public double getValue(int index)
	{
		return values[index];
	}
	
	public SliderGroup()
	{
		super();
		setupListeners();
	}
}

