package common;

import java.util.Iterator;
import java.util.LinkedList;

public class SparseIterator<E> implements Iterator<E> {

	LinkedList<E> list;
	int max_size;
	int fraction= 1;
	int pos = 0;
	Iterator<E> itr;
	
	public SparseIterator(LinkedList<E> list, Iterator<E> itr, int max_size)
	{
		this.list = list;
		this.max_size = max_size;
		fraction = list.size()/max_size;
		this.itr = itr;
	}
	
	@Override
	public boolean hasNext() {
		// TODO Auto-generated method stub
		if(pos+fraction < list.size()) return true;
		else return false;
	}

	@Override
	public E next() {
		// TODO Auto-generated method stub
		if(pos==0)
		{
			pos++;
			return itr.next();
		}
		if(pos==1)pos--;
		while(fraction > 0 &&((int)((pos+1)/fraction) == (int)(pos/fraction)))
		{
			itr.next();
			pos++;
		}
		pos++;
		return itr.next();
	}

	@Override
	public void remove() {
		// TODO Auto-generated method stub
		itr.remove();
	}

}
