package common;

import java.util.Iterator;
import java.util.LinkedList;

public class TruncatedIterator<E> implements Iterator<E> {

	LinkedList<E> list;
	int max_size;
	int pos = 0;
	Iterator<E> itr;
	
	public TruncatedIterator(LinkedList<E> list, Iterator<E> itr, int max_size)
	{
		this.list = list;
		this.max_size = max_size;
		this.itr = itr;
	}
	
	@Override
	public boolean hasNext() {
		// TODO Auto-generated method stub
		return (pos < Math.min(max_size,list.size()));
	}

	@Override
	public E next() {
		// TODO Auto-generated method stub
		pos++;
		return itr.next();
	}

	@Override
	public void remove() {
		// TODO Auto-generated method stub
		itr.remove();
	}

}
